import { ComponentClass, ComponentType } from 'react';
import { Observable } from 'rxjs';
export declare type WithRXSelectorResultPropsOnly<P> = Observable<Partial<P>>;
export declare type WithRXSelectorResultWithEffects<P> = {
    props$: Observable<Partial<P>>;
    effects$: Observable<void>;
};
export declare type ComponentDecorator<P> = (Target: ComponentType<P>) => ComponentClass<P>;
export declare type WithRXSelectorResult<P> = WithRXSelectorResultPropsOnly<P> | WithRXSelectorResultWithEffects<P>;
export declare type WithRXSelector<P> = (props$: Observable<Readonly<P>>) => WithRXSelectorResult<P>;
export declare function withRX<P extends object = never>(select: WithRXSelector<P>): ComponentDecorator<P>;
